#ifndef GSLOOP_TYPES_H
#define GSLOOP_TYPES_H

#include <libgsloop_config.h>

#include <librn.h>

#include <libgsloop.h>
#include <ptx_misc.h>

struct gsloop;
struct gsloop_client;
union gsloop_con;


typedef int	(*gsloop_close_fn_t)		(union gsloop_con	*gsloop_con);
typedef int	(*gsloop_client_detach_fn_t)	(struct gsloop_client	*client);


struct gsloop {
	rn_t				rn;

	struct gsloop_attr		attr;

	union gsloop_con		*con_list;
};


#define GSLOOP_CON_COMMON				\
	union gsloop_con		*next;		\
	struct gsloop			*gsloop;	\
	int				fd;		\
	gsloop_close_fn_t		close;



struct gsloop_server {
	/*
	 * set by us
	 */
	GSLOOP_CON_COMMON;

	gsloop_close_fn_t		client_close;		/* client's close funktion */
	
	gsloop_client_detach_fn_t	client_detach;		/* called when client is detached */

	unsigned int			active_clients;

	/*
	 * set by user
	 */
	struct gsloop_server_attr	attr;
};

struct gsloop_client {
	/*
	 * set by us
	 */
	GSLOOP_CON_COMMON;

	struct gsloop_server		*server;		/* our server */
	
	/*
	 * set by user
	 */
	gsloop_client_event_fn_t	event;			/* client's function, called when client is ready */
	void				*event_data;

};

struct gsloop_common {
	GSLOOP_CON_COMMON;
};


union gsloop_con {
	struct gsloop_server		server;
	struct gsloop_client		client;
	struct gsloop_common		common;
};
typedef union gsloop_con	con;

#endif	/* !GSLOOP_TYPES_H */
